(function() {
    var Promise = require("bluebird");
    var gen1_promise = function(block) {
        return new Promise(function(continuation, fail) {
            function resolve(p, block) {
                if (p !== void 0 && typeof p.then === "function") {
                    p.then(function(result) {
                        try {
                            block(result);
                        } catch (e) {
                            fail(e);
                        }
                    }, fail);
                } else {
                    block(p);
                }
            }
            block(resolve, continuation);
        });
    };
    var self = this;
    var fs, path, pogo, argv, findParentDirectoryWhere, findQo, defineTasks, isFunctionAsynchronous, parseArgs, runTaskFromWithArgs, displayTasks;
    fs = require("fs");
    path = require("path");
    pogo = require("pogo");
    argv = require("optimist").argv;
    findParentDirectoryWhere = function(predicate) {
        var findParentWhere, gen2_asyncResult;
        return gen1_promise(function(gen3_resolve, continuation) {
            findParentWhere = function(dir, p) {
                var gen4_asyncResult, gen5_asyncResult;
                return gen1_promise(function(gen3_resolve, continuation) {
                    gen3_resolve(p(dir), function(gen5_asyncResult) {
                        gen3_resolve(function() {
                            if (!gen5_asyncResult) {
                                return gen1_promise(function(gen3_resolve, continuation) {
                                    newDir = path.normalize(path.join(dir, ".."));
                                    gen3_resolve(function() {
                                        if (dir !== "/") {
                                            return gen1_promise(function(gen3_resolve, continuation) {
                                                gen3_resolve(findParentWhere(newDir, p), continuation);
                                            });
                                        }
                                    }(), continuation);
                                });
                            } else {
                                return dir;
                            }
                        }(), continuation);
                    });
                });
            };
            gen3_resolve(findParentWhere(process.cwd(), predicate), continuation);
        });
    };
    findQo = function() {
        var gen6_asyncResult, foundDir;
        return gen1_promise(function(gen3_resolve, continuation) {
            gen3_resolve(findParentDirectoryWhere(function(dir) {
                return new Promise(function(onSuccess) {
                    return fs.exists(path.join(dir, "qo.pogo"), function(e) {
                        return onSuccess(e);
                    });
                });
            }), function(gen6_asyncResult) {
                foundDir = gen6_asyncResult;
                if (foundDir) {
                    return continuation(path.join(foundDir, "qo.pogo"));
                } else {
                    continuation();
                }
            });
        });
    };
    defineTasks = function() {
        var tasks;
        tasks = {};
        global.task = function(name, $function, gen7_options) {
            var self = this;
            var description, desc;
            description = gen7_options !== void 0 && Object.prototype.hasOwnProperty.call(gen7_options, "description") && gen7_options.description !== void 0 ? gen7_options.description : void 0;
            desc = gen7_options !== void 0 && Object.prototype.hasOwnProperty.call(gen7_options, "desc") && gen7_options.desc !== void 0 ? gen7_options.desc : void 0;
            return tasks[name] = {
                "function": $function,
                description: desc || description,
                name: name
            };
        };
        return tasks;
    };
    isFunctionAsynchronous = function(f) {
        return /function(.*continuation)/.test(f.toString());
    };
    parseArgs = function() {
        var args, opts, s;
        args = argv._.slice(0);
        opts = {};
        for (s in argv) {
            (function(s) {
                if (argv.hasOwnProperty(s) && s !== "_" && s !== "$0") {
                    opts[s] = argv[s];
                }
            })(s);
        }
        return {
            arguments: args,
            options: opts
        };
    };
    runTaskFromWithArgs = function(name, tasks, args) {
        var task, gen8_asyncResult;
        return gen1_promise(function(gen3_resolve, continuation) {
            task = tasks[name];
            gen3_resolve(function() {
                if (task) {
                    return gen1_promise(function(gen3_resolve, continuation) {
                        result = task.function(args.arguments, args.options);
                        gen3_resolve(function() {
                            if (result && result.then instanceof Function) {
                                return gen1_promise(function(gen3_resolve, continuation) {
                                    gen3_resolve(result, continuation);
                                });
                            }
                        }(), continuation);
                    });
                } else {
                    process.stderr.write("could not find task `" + name + "'");
                    return process.exit(1);
                }
            }(), continuation);
        });
    };
    displayTasks = function(tasks) {
        var tn;
        console.log("tasks:");
        console.log();
        for (tn in tasks) {
            (function(tn) {
                var task, description;
                if (tasks.hasOwnProperty(tn)) {
                    task = tasks[tn];
                    description = function() {
                        if (task.description) {
                            return ", " + task.description;
                        } else {
                            return "";
                        }
                    }();
                    console.log("    " + task.name + "" + description);
                    console.log();
                }
            })(tn);
        }
        return void 0;
    };
    exports.run = function() {
        var self = this;
        var gen9_asyncResult, qo, gen10_asyncResult;
        return gen1_promise(function(gen3_resolve, continuation) {
            gen3_resolve(findQo(), function(gen9_asyncResult) {
                qo = gen9_asyncResult;
                gen3_resolve(function() {
                    if (qo) {
                        return gen1_promise(function(gen3_resolve, continuation) {
                            tasks = defineTasks();
                            process.chdir(path.dirname(qo));
                            require(qo);
                            taskName = argv._.shift();
                            gen3_resolve(function() {
                                if (taskName) {
                                    return gen1_promise(function(gen3_resolve, continuation) {
                                        gen3_resolve(runTaskFromWithArgs(taskName, tasks, parseArgs()), continuation);
                                    });
                                } else {
                                    return displayTasks(tasks);
                                }
                            }(), continuation);
                        });
                    } else {
                        process.stderr.write("couldn't find `qo.pogo` in any parent directory");
                        return process.exit(1);
                    }
                }(), continuation);
            });
        });
    };
}).call(this);